/* -*- buffer-read-only: t -*- vi: set ro:
#line 382
   THIS FILE IS GENERATED AUTOMATICALLY.  PLEASE DO NOT EDIT.
#line 382
*/
#ifdef HAVE_CONFIG_H
# include <config.h>
#endif
#include <sys/types.h>
#include "mailfrom.h"
#include "prog.h"
#include "builtin.h"

#line 17 "bi_string.m4"
/* This file is part of mailfrom filter.             -*- c -*-
#line 17
   Copyright (C) 2006 Sergey Poznyakoff
#line 17

#line 17
   This program is free software; you can redistribute it and/or modify
#line 17
   it under the terms of the GNU General Public License as published by
#line 17
   the Free Software Foundation; either version 2, or (at your option)
#line 17
   any later version.
#line 17

#line 17
   This program is distributed in the hope that it will be useful,
#line 17
   but WITHOUT ANY WARRANTY; without even the implied warranty of
#line 17
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#line 17
   GNU General Public License for more details.
#line 17

#line 17
   You should have received a copy of the GNU General Public License
#line 17
   along with this program; if not, write to the Free Software
#line 17
   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
#line 17
   MA 02110-1301 USA */

void
#line 19
bi_toupper(eval_environ_t env)
#line 19 "bi_string.m4"
{
#line 19
	
#line 19
char * string = (char *) get_arg(env, 0);
#line 19
        
#line 19
        adjust_stack(env, 1);
#line 19

#line 19
	if (prog_trace_option & BUILTIN_MASK_string)
#line 19
		prog_trace(env, "toupper %s",string);;
#line 19

{
	char *s = strcpy(heap_reserve(env, strlen(string) + 1), string);
	char *p;
	for (p = s; *p; p++)
		*p = toupper(*p);
	do {
#line 25
push(env, (STKVAL) (s));
#line 25
return;
#line 25
} while (0);
}
}

void
#line 29
bi_tolower(eval_environ_t env)
#line 29 "bi_string.m4"
{
#line 29
	
#line 29
char * string = (char *) get_arg(env, 0);
#line 29
        
#line 29
        adjust_stack(env, 1);
#line 29

#line 29
	if (prog_trace_option & BUILTIN_MASK_string)
#line 29
		prog_trace(env, "tolower %s",string);;
#line 29

{
	char *s = strcpy(heap_reserve(env, strlen(string) + 1), string);
	char *p;
	for (p = s; *p; p++)
		*p = tolower(*p);
	do {
#line 35
push(env, (STKVAL) (s));
#line 35
return;
#line 35
} while (0);
}
}

void
#line 39
bi_length(eval_environ_t env)
#line 39 "bi_string.m4"
{
#line 39
	
#line 39
char * string = (char *) get_arg(env, 0);
#line 39
        
#line 39
        adjust_stack(env, 1);
#line 39

#line 39
	if (prog_trace_option & BUILTIN_MASK_string)
#line 39
		prog_trace(env, "length %s",string);;
#line 39

{
	do {
#line 41
push(env, (STKVAL) (strlen(string)));
#line 41
return;
#line 41
} while (0);
}
}

void
#line 45
bi_substring(eval_environ_t env)
#line 45 "bi_string.m4"
{
#line 45
	
#line 45
char * string = (char *) get_arg(env, 2);
#line 45
        long  start = (long ) get_arg(env, 1);
#line 45
        long  end = (long ) get_arg(env, 0);
#line 45
        
#line 45
        adjust_stack(env, 3);
#line 45

#line 45
	if (prog_trace_option & BUILTIN_MASK_string)
#line 45
		prog_trace(env, "substring %s %lu %lu",string, start, end);;
#line 45

{
	long len = strlen(string);
	char *s;
	
	if (end < 0)
		end = len - 1;
	if (end < start) {
		long t = end;
		end = start;
		start = t;
	}

		if (!(start < len && end < len))
			do {
#line 59
		if (env_catch(env, mf_range) == 0)
#line 59
			return ;
#line 59
		else
#line 59
			runtime_error(env,
#line 59
				                                                  "substring: " "argument out of range");
#line 59
	} while (0) 
#line 59
;
#line 59
;
	
	len = end - start + 1;
	s = heap_reserve(env, len + 1);
	memcpy(s, string + start, len);
	s[len] = 0;
	
	do {
#line 66
push(env, (STKVAL) (s));
#line 66
return;
#line 66
} while (0);
}
}

void
#line 70
bi_substr(eval_environ_t env)
#line 70 "bi_string.m4"
{
#line 70
	
#line 70
char * string = (char *) get_arg(env, 2);
#line 70
        long  start = (long ) get_arg(env, 1);
#line 70
        long  nbytes = (long ) get_arg(env, 0);
#line 70
        
#line 70
        adjust_stack(env, 3);
#line 70

#line 70
	if (prog_trace_option & BUILTIN_MASK_string)
#line 70
		prog_trace(env, "substr %s %lu %lu",string, start, nbytes);;
#line 70

{
	long len = strlen(string);
	char *s;
	
		if (!(start >= 0))
#line 75
			do {
#line 75
		if (env_catch(env, mf_range) == 0)
#line 75
			return ;
#line 75
		else
#line 75
			runtime_error(env,
#line 75
				                                                  "substr: " "argument out of range");
#line 75
	} while (0) 
#line 75
;
#line 75
;
	if (nbytes == 0)
		nbytes = len - start;
	
	s = heap_reserve(env, nbytes + 1);
	memcpy(s, string + start, nbytes);
	s[nbytes] = 0;
	
	do {
#line 83
push(env, (STKVAL) (s));
#line 83
return;
#line 83
} while (0);
}
}

void
#line 87
bi_index(eval_environ_t env)
#line 87 "bi_string.m4"
{
#line 87
	
#line 87
char * str = (char *) get_arg(env, 1);
#line 87
        char * sub = (char *) get_arg(env, 0);
#line 87
        
#line 87
        adjust_stack(env, 2);
#line 87

#line 87
	if (prog_trace_option & BUILTIN_MASK_string)
#line 87
		prog_trace(env, "index %s %s",str, sub);;
#line 87

{
	char *p = strstr(str, sub);
	do {
#line 90
push(env, (STKVAL) (p ? p - str : -1));
#line 90
return;
#line 90
} while (0);
}
}

void
#line 94
bi_rindex(eval_environ_t env)
#line 94 "bi_string.m4"
{
#line 94
	
#line 94
char * str = (char *) get_arg(env, 1);
#line 94
        char * sub = (char *) get_arg(env, 0);
#line 94
        
#line 94
        adjust_stack(env, 2);
#line 94

#line 94
	if (prog_trace_option & BUILTIN_MASK_string)
#line 94
		prog_trace(env, "rindex %s %s",str, sub);;
#line 94

{
	int slen, xlen, rc;
	char *p, *s, *x;
	char *temp;

	slen = strlen(str);
	xlen = strlen(sub);
	temp = heap_tempspace(env, xlen + slen + 2);
	s = temp;
	x = s + slen + 1;
	
	/* Reverse str */                     
#define REV(v,s,l)                                         \
	l = strlen(s);                                     \
	v[l] = 0;                                          \
	for (p = v + l - 1; p >= v; p--, s++)              \
		*p = *s;

	REV(s,str,slen);
	REV(x,sub,xlen);

	p = strstr(s, x);
	if (p)
		rc = slen - (p - s + xlen);
	else
		rc = -1;
	
	do {
#line 122
push(env, (STKVAL) (rc));
#line 122
return;
#line 122
} while (0);
}
}

void
#line 126
bi_revstr(eval_environ_t env)
#line 126 "bi_string.m4"
{
#line 126
	
#line 126
char * str = (char *) get_arg(env, 0);
#line 126
        
#line 126
        adjust_stack(env, 1);
#line 126

#line 126
	if (prog_trace_option & BUILTIN_MASK_string)
#line 126
		prog_trace(env, "revstr %s",str);;
#line 126

{
	int len = strlen(str);
	char *p;
	char *s = heap_reserve(env, len + 1);

	s[len] = 0;
	for (p = s + len - 1; p >= s; p--, str++)
		*p = *str;
	do {
#line 135
push(env, (STKVAL) (s));
#line 135
return;
#line 135
} while (0);
}
}


#line 139
void
#line 139
string_init_builtin()
#line 139
{
#line 139
	#line 19 "bi_string.m4"
va_builtin_install_ex("toupper", bi_toupper, 0, 0, dtype_string,  1, 0,  dtype_string);
#line 29 "bi_string.m4"
va_builtin_install_ex("tolower", bi_tolower, 0, 0, dtype_string,  1, 0,  dtype_string);
#line 39 "bi_string.m4"
va_builtin_install_ex("length", bi_length, 0, 0, dtype_number,  1, 0,  dtype_string);
#line 45 "bi_string.m4"
va_builtin_install_ex("substring", bi_substring, 0, 0, dtype_string,  3, 0,  dtype_string, dtype_number, dtype_number);
#line 70 "bi_string.m4"
va_builtin_install_ex("substr", bi_substr, 0, 0, dtype_string,  3, 1,  dtype_string, dtype_number, dtype_number);
#line 87 "bi_string.m4"
va_builtin_install_ex("index", bi_index, 0, 0, dtype_number,  2, 0,  dtype_string, dtype_string);
#line 94 "bi_string.m4"
va_builtin_install_ex("rindex", bi_rindex, 0, 0, dtype_number,  2, 0,  dtype_string, dtype_string);
#line 126 "bi_string.m4"
va_builtin_install_ex("revstr", bi_revstr, 0, 0, dtype_string,  1, 0,  dtype_string);

#line 139 "bi_string.m4"
		
#line 139
}
#line 0

#line 0

